//
// Copyright 2009-2011 Facebook
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// UI
#import "TTButton.h"

@class TTLauncherItem;
@class TTLabel;

@interface TTLauncherButton : TTButton {
  TTLauncherItem* _item;
  TTLabel*        _badge;
  TTButton*       _closeButton;

  BOOL _dragging;
  BOOL _editing;
}

@property (nonatomic, readonly) TTLauncherItem* item;
@property (nonatomic, readonly) TTButton*       closeButton;
@property (nonatomic)           BOOL            dragging;
@property (nonatomic)           BOOL            editing;

- (id)initWithItem:(TTLauncherItem*)item;

@end
