//
// Copyright 2009-2011 Facebook
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

#import "TTTableItem.h"

// Core
#import "TTCorePreprocessorMacros.h"

// UI
#import "TTTableViewCell.h"


///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
@implementation TTTableItem

@synthesize userInfo = _userInfo;


///////////////////////////////////////////////////////////////////////////////////////////////////
- (void)dealloc {
  TT_RELEASE_SAFELY(_userInfo);

  [super dealloc];
}


///////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////
#pragma mark -
#pragma mark NSCoding


///////////////////////////////////////////////////////////////////////////////////////////////////
- (id)initWithCoder:(NSCoder*)decoder {
	self = [self init];
  if (self) {
  }

  return self;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
- (void)encodeWithCoder:(NSCoder*)encoder {
}


///////////////////////////////////////////////////////////////////////////////////////////////////
- (Class)cellClass {
  return [TTTableViewCell class];
}


///////////////////////////////////////////////////////////////////////////////////////////////////
- (NSString*)cellIdentifier {
  return NSStringFromClass([self cellClass]);
}


///////////////////////////////////////////////////////////////////////////////////////////////////
- (TTTableViewCell*)newCell {
  TTTableViewCell *cell = [[[self cellClass] alloc] initWithStyle:UITableViewCellStyleDefault
                                 reuseIdentifier:[self cellIdentifier]];
  return cell;
}


@end
